/***************************************************
//Web: http://www.buydisplay.com
EastRising Technology Co.,LTD
****************************************************/

#include <bcm2835.h>
#include <stdio.h>
#include "gc9107.h"

char buffer[TFT_WIDTH * TFT_HEIGHT * 2];

void command(char cmd) {
    bcm2835_gpio_write(DC, LOW);
    bcm2835_spi_transfer(cmd);
}

void data(char cmd) {
    bcm2835_gpio_write(DC, HIGH);
    bcm2835_spi_transfer(cmd);
}

void gc9107_begin()
{
    bcm2835_gpio_fsel(RST, BCM2835_GPIO_FSEL_OUTP);
    bcm2835_gpio_fsel(DC, BCM2835_GPIO_FSEL_OUTP);

    bcm2835_spi_begin();
    bcm2835_spi_setBitOrder(BCM2835_SPI_BIT_ORDER_MSBFIRST);     //The default
    bcm2835_spi_setDataMode(BCM2835_SPI_MODE0);                  //The default
    bcm2835_spi_setClockDivider(BCM2835_SPI_CLOCK_DIVIDER_64);  //The default
    bcm2835_spi_chipSelect(BCM2835_SPI_CS0);                     //The default
    bcm2835_spi_setChipSelectPolarity(BCM2835_SPI_CS0, LOW);     //the default

    bcm2835_gpio_write(RST, HIGH);
    bcm2835_delay(10);
    bcm2835_gpio_write(RST, LOW);
    bcm2835_delay(10);
    bcm2835_gpio_write(RST, HIGH);

   	 //************* Start Initial Sequence **********// 
 	
 command(0xB0);		
 data(0xC0); 
 command(0xB2);			
 data(0x2F); 
 command(0xB3);		
 data(0x03);
 command(0xB6);		
 data(0x19); 
 command(0xB7);		
 data(0x01);  
	
 command(0xAC);
 data(0xCB);
 command(0xAB); 
 data(0x0e);
		
 command(0xB4);	
 data(0x04);
	
 command(0xA8);
 data(0x19);

 command(0x3A);		
 data(0x05); 
 
 command(0x36);		
 data(0x0c8);
  
 command(0xb8);
 data(0x08);
 
 command(0xE8);
 data(0x24);

 command(0xE9);
 data(0x48);

 command(0xea);	
 data(0x22);

 			
 command(0xC6);
 data(0x30);
 command(0xC7);
 data(0x18);

 command(0xF0);
 data(0x1F);
 data(0x28);
 data(0x04);
 data(0x3E);
 data(0x2A);
 data(0x2E);
 data(0x20);
 data(0x00);
 data(0x0C);
 data(0x06);
 data(0x00);
 data(0x1C);
 data(0x1F);
 data(0x0f);

 command(0xF1); 
 data(0X00);
 data(0X2D);
 data(0X2F);
 data(0X3C);
 data(0X6F);
 data(0X1C);
 data(0X0B);
 data(0X00);
 data(0X00);
 data(0X00);
 data(0X07);
 data(0X0D);
 data(0X11);
 data(0X0f);  
							 	
  command(0x21);	

  command(0x11); 
  bcm2835_delay(120);
  command(0x29); 


  
  gc9107_clear();


}

void gc9107_clear() {
    int i;
    for(i = 0; i < sizeof(buffer); i++)
    {
        buffer[i] = 0;
    }
}

void gc9107_draw_point(int x, int y, uint16_t hwColor) {
    if(x >= TFT_WIDTH || y >= TFT_HEIGHT)
    {
        return;
    }
    buffer[x * 2 + y * TFT_WIDTH * 2] = hwColor >> 8;
    buffer[x * 2 + y * TFT_WIDTH * 2 + 1] = hwColor;
}

void gc9107_char1616(uint8_t x, uint8_t y, uint8_t chChar, uint16_t hwColor) {
    uint8_t i, j;
    uint8_t chTemp = 0, y0 = y;

    for (i = 0; i < 32; i ++) {
        chTemp = Font1612[chChar - 0x30][i];
        for (j = 0; j < 8; j ++) {
            if (chTemp & 0x80) {
                gc9107_draw_point(x, y, hwColor);
            } else {
                gc9107_draw_point(x, y, 0);
            }
            chTemp <<= 1;
            y++;
            if ((y - y0) == 16) {
                y = y0;
                x++;
                break;
            }
        }
    }
}

void gc9107_char3216(uint8_t x, uint8_t y, uint8_t chChar, uint16_t hwColor) {
    uint8_t i, j;
    uint8_t chTemp = 0, y0 = y; 

    for (i = 0; i < 64; i++) {
        chTemp = Font3216[chChar - 0x30][i];
        for (j = 0; j < 8; j++) {
            if (chTemp & 0x80) {
                gc9107_draw_point(x, y, hwColor);
            } else {
                gc9107_draw_point(x, y, 0);
            }

            chTemp <<= 1;
            y++;
            if ((y - y0) == 32) {
                y = y0;
                x++;
                break;
            }
        }
    }
}

void gc9107_char(uint8_t x, uint8_t y, char acsii, char size, char mode, uint16_t hwColor) {
    uint8_t i, j, y0=y;
    char temp;
    uint8_t ch = acsii - ' ';
    for(i = 0;i<size;i++) {
        if(size == 12)
        {
            if(mode)temp=Font1206[ch][i];
            else temp = ~Font1206[ch][i];
        }
        else 
        {            
            if(mode)temp=Font1608[ch][i];
            else temp = ~Font1608[ch][i];
        }
        for(j =0;j<8;j++)
        {
            if(temp & 0x80) gc9107_draw_point(x, y, hwColor);
            else gc9107_draw_point(x, y, 0);
            temp <<=1;
            y++;
            if((y-y0)==size)
            {
                y = y0;
                x ++;
                break;
            }
        }
    }
}

void gc9107_string(uint8_t x, uint8_t y, const char *pString, uint8_t Size, uint8_t Mode, uint16_t hwColor) {
    while (*pString != '\0') {       
        if (x > (TFT_WIDTH - Size / 2)) {
            x = 0;
            y += Size;
            if (y > (TFT_HEIGHT - Size)) {
                y = x = 0;
            }
        }
        
        gc9107_char(x, y, *pString, Size, Mode, hwColor);
        x += Size / 2;
        pString ++;
    }
}

void gc9107_mono_bitmap(uint8_t x, uint8_t y, const uint8_t *pBmp, char chWidth, char chHeight, uint16_t hwColor) {
    uint8_t i, j, byteWidth = (chWidth + 7) / 8;
    for(j = 0; j < chHeight; j++) {
        for(i = 0; i <chWidth; i ++) {
            if(*(pBmp + j * byteWidth + i / 8) & (128 >> (i & 7))) {
                gc9107_draw_point(x + i, y + j, hwColor);
            }
        }
    }        
}

void gc9107_bitmap24(uint8_t x, uint8_t y, uint8_t *pBmp, char chWidth, char chHeight) {
    uint8_t i, j;
    uint16_t hwColor;
    uint32_t temp;

    for(j = 0; j < chHeight; j++) {
        for(i = 0; i < chWidth; i ++) {
            temp = *(unsigned int*)(pBmp + i * 3 + j * 3 * chWidth);
            hwColor = RGB(((temp >> 16) & 0xFF),
                          ((temp >> 8) & 0xFF),
                           (temp & 0xFF));
            gc9107_draw_point(x + i, y + chHeight - 1 - j, hwColor);
        }
    }
}


void gc9107_bitmap16(uint8_t x, uint8_t y, const uint8_t *pBmp, char chWidth, char chHeight) {
    uint8_t i, j,temp;
    uint16_t hwColor;


    for(j = 0; j < chHeight; j++) {
        for(i = 0; i < chWidth; i ++) {
            hwColor= (*pBmp++);
            hwColor = hwColor<<8;
            temp = (*pBmp++);
	    hwColor = hwColor|temp;         
            gc9107_draw_point(x + i, y + j, hwColor);
        }
    }
}


void gc9107_display() {
 
    command(0x2a);
    data(2);
    data(2);
    data((TFT_WIDTH+1) >> 8);
    data(TFT_WIDTH+1);

    command(0x2b);
    data(1);
    data(1);
    data((TFT_HEIGHT) >> 8);
    data(TFT_HEIGHT);

    command(0x2C);
    bcm2835_gpio_write(DC, HIGH);
    bcm2835_spi_transfern(buffer, sizeof(buffer));
}

void gc9107_clear_screen(uint16_t hwColor) {
    uint16_t i, j;
    for(i = 0; i < TFT_HEIGHT; i++) {
        for(j = 0; j < TFT_WIDTH; j ++) {
            gc9107_draw_point(j, i, hwColor);
        }
    }
}

